function varargout = FysaSettings(varargin)
% FYSASETTINGS MATLAB code for FysaSettings.fig
%      FYSASETTINGS, by itself, creates a new FYSASETTINGS or raises the existing
%      singleton*.
%
%      H = FYSASETTINGS returns the handle to a new FYSASETTINGS or the handle to
%      the existing singleton*.
%
%      FYSASETTINGS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FYSASETTINGS.M with the given input arguments.
%
%      FYSASETTINGS('Property','Value',...) creates a new FYSASETTINGS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before FysaSettings_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to FysaSettings_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help FysaSettings

% Last Modified by GUIDE v2.5 15-Oct-2015 23:00:03

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @FysaSettings_OpeningFcn, ...
                   'gui_OutputFcn',  @FysaSettings_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before FysaSettings is made visible.
function FysaSettings_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to FysaSettings (see VARARGIN)

% Choose default command line output for FysaSettings
handles.output = hObject;

handles.fysa = varargin{1};
handles.objectsettings = ObjectSettings(handles.fysa);

pbUpdate_Callback(hObject, eventdata, handles);
update_table(handles);
update_dropdown(handles);
update_edit(handles);
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes FysaSettings wait for user response (see UIRESUME)
% uiwait(handles.figure1);

function update_table(handles);
    set(handles.uitable1,'Data',handles.objectsettings.list_properties_table());
    
function update_dropdown(handles);
    set(handles.popupmenu1,'string',handles.objectsettings.observable_properties());

function update_edit(handles);
    contents = cellstr(get(handles.popupmenu1,'String'));
    set(handles.edit1,'string',handles.fysa.(contents{get(handles.popupmenu1,'Value')}));
    
% --- Outputs from this function are returned to the command line.
function varargout = FysaSettings_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pbUpdate.
function pbUpdate_Callback(hObject, eventdata, handles)
% hObject    handle to pbUpdate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
update_table(handles);



% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1
update_edit(handles);

% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double
contents = cellstr(get(handles.popupmenu1,'String'));
value = get(hObject,'String');
numvalue = str2double(value);
if ~isnan(numvalue)
    handles.fysa.(contents{get(handles.popupmenu1,'Value')}) = numvalue;
else
    handles.fysa.(contents{get(handles.popupmenu1,'Value')}) = value;
end
update_table(handles);
    

% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
