function varargout = plotPixel(varargin)
% PLOTPIXEL MATLAB code for plotPixel.fig
%      PLOTPIXEL, by itself, creates a new PLOTPIXEL or raises the existing
%      singleton*.
%
%      H = PLOTPIXEL returns the handle to a new PLOTPIXEL or the handle to
%      the existing singleton*.
%
%      PLOTPIXEL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in PLOTPIXEL.M with the given input arguments.
%
%      PLOTPIXEL('Property','Value',...) creates a new PLOTPIXEL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before plotPixel_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to plotPixel_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help plotPixel

% Last Modified by GUIDE v2.5 12-Oct-2015 16:46:37

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @plotPixel_OpeningFcn, ...
                   'gui_OutputFcn',  @plotPixel_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before plotPixel is made visible.
function plotPixel_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to plotPixel (see VARARGIN)

% Choose default command line output for plotPixel
handles.output = hObject;

handles.fysa = varargin{1};

%Listeners
handles.coordL = event.listener(handles.fysa, 'changedCoord', @(o,e) update_edits(handles));

update_plot(handles);

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes plotPixel wait for user response (see UIRESUME)
% uiwait(handles.figure1);

function update_edits(handles)
    set(handles.edX, 'string', handles.fysa.selX);
    set(handles.edY, 'string', handles.fysa.selY);
    update_plot(handles);

function update_plot(handles)
    x = handles.fysa.selX; y = handles.fysa.selY;
    abp = handles.fysa.abp;
    perf = handles.fysa.extractPixel(x,y);
    hold(handles.axes1,'off');
    scatter(abp,perf,'b*','parent', handles.axes1);
    hold(handles.axes1,'on');
    %Extract knot and coefficients
    knot = handles.fysa.pictures.('knotpic')(x,y);
    coeffs1 = [handles.fysa.pictures.('slope1')(x,y) handles.fysa.pictures.('intercept1')(x,y)];
    coeffs2 = [handles.fysa.pictures.('slope2')(x,y) handles.fysa.pictures.('intercept2')(x,y)];
    %Plot first linesegment
    fittedX = linspace(min(abp), knot, 2);
    fittedY = polyval(coeffs1, fittedX);
    plot(fittedX, fittedY, 'r-', 'LineWidth', 3, 'parent', handles.axes1);
    %plot second linesegment
    fittedX2 = linspace(knot, max(abp), 3);
    fittedY2 = polyval(coeffs2, fittedX2);
    plot(fittedX2, fittedY2, 'r-', 'LineWidth', 3, 'parent', handles.axes1);
    handles.axes1.XLabel.String = 'Mean Arterial Pressure (mmHg)';
    handles.axes1.YLabel.String = 'Arbitrary Flow Units';
    hold(handles.fysa.handles.im.Parent, 'on');
    try delete(handles.fysa.handles.selPixel); catch; end;
    handles.fysa.handles.selPixel = plot(handles.fysa.handles.im.Parent,handles.fysa.selY,handles.fysa.selX,'go');



% --- Outputs from this function are returned to the command line.
function varargout = plotPixel_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function edX_Callback(hObject, eventdata, handles)
% hObject    handle to edX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edX as text
%        str2double(get(hObject,'String')) returns contents of edX as a double
handles.fysa.selX = str2double(get(hObject,'String'));
%update_plot(handles);

% --- Executes during object creation, after setting all properties.
function edX_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edY_Callback(hObject, eventdata, handles)
% hObject    handle to edY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edY as text
%        str2double(get(hObject,'String')) returns contents of edY as a double
handles.fysa.selY = str2double(get(hObject,'String'));
%update_plot(handles);

% --- Executes during object creation, after setting all properties.
function edY_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pbUp.
function pbUp_Callback(hObject, eventdata, handles)
% hObject    handle to pbUp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%set(handles.edX, 'string', str2double(get(handles.edX,'String'))-1);
handles.fysa.selX = handles.fysa.selX-1; 
%update_plot(handles);

% --- Executes on button press in pbDown.
function pbDown_Callback(hObject, eventdata, handles)
% hObject    handle to pbDown (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.fysa.selX = handles.fysa.selX+1; 
%update_plot(handles);

% --- Executes on button press in pbRight.
function pbRight_Callback(hObject, eventdata, handles)
% hObject    handle to pbRight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%set(handles.edY, 'string', str2double(get(handles.edY,'String'))+1);
handles.fysa.selY = handles.fysa.selY+1; 
%update_plot(handles);


% --- Executes on button press in pbLeft.
function pbLeft_Callback(hObject, eventdata, handles)
% hObject    handle to pbLeft (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%set(handles.edY, 'string', str2double(get(handles.edY,'String'))-1);
handles.fysa.selY = handles.fysa.selY-1; 
%update_plot(handles);


% --- Executes during object deletion, before destroying properties.
function figure1_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
try delete(handles.fysa.handles.selPixel); catch; end;
